<?php
namespace Ep\Wp\Middleware;

use Ep\Wp\Plugin\TranslationCache;
use Interop\Http\Server\MiddlewareInterface;
use Interop\Http\Server\RequestHandlerInterface;
use Psr\Container\ContainerInterface;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;

/**
 * Omogućava korištenje custom pluginova.
 *
 * @package Ep\Wp\Middleware
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-wordpress
 */
class Plugins implements MiddlewareInterface
{
    /** @var ContainerInterface */
    private $container;

    /**
     * Plugins constructor.
     *
     * @param ContainerInterface $container
     */
    public function __construct(ContainerInterface $container)
    {
        $this->container = $container;
    }

    /**
     * Inicijalizira neke naše pluginove.
     *
     * @param ServerRequestInterface $request
     * @param RequestHandlerInterface $handler
     *
     * @return ResponseInterface
     */
    public function process(ServerRequestInterface $request, RequestHandlerInterface $handler)
    {
        require_once ABSPATH . 'wp-includes/plugin.php';

        new TranslationCache($this->container->get(TranslationCache::CACHE_NAME));

        return $handler->handle($request);
    }
}